
_main:

;freq.c,40 :: 		void main() {
;freq.c,47 :: 		ANSELA = 0;                       // Configure PORTA pins as digital
	CLRF        ANSELA+0 
;freq.c,48 :: 		ANSELB = 0;                       // Configure PORTB pins as digital
	CLRF        ANSELB+0 
;freq.c,49 :: 		ANSELC = 0;                       // Configure PORTC pins as digital
	CLRF        ANSELC+0 
;freq.c,50 :: 		ANSELD = 0;                       // Configure PORTD pins as digital
	CLRF        ANSELD+0 
;freq.c,51 :: 		ANSELE = 0;                       // Configure PORTE pins as digital
	CLRF        ANSELE+0 
;freq.c,52 :: 		ADCON0 = 0;                       // A/D off
	CLRF        ADCON0+0 
;freq.c,53 :: 		ADCON1 = 0x0f;                    // all digital
	MOVLW       15
	MOVWF       ADCON1+0 
;freq.c,54 :: 		CM1CON0 = 0;                      // disable 18F45K22 comparator
	CLRF        CM1CON0+0 
;freq.c,55 :: 		CM2CON0 = 0;                      // disable 18F45K22 comparator
	CLRF        CM2CON0+0 
;freq.c,57 :: 		LATA = 0;                         // all off
	CLRF        LATA+0 
;freq.c,58 :: 		LATB = 0xff;                      // disable GLCD if fitted
	MOVLW       255
	MOVWF       LATB+0 
;freq.c,59 :: 		LATC = 0;                         // all off
	CLRF        LATC+0 
;freq.c,60 :: 		TRISA = 0xC0;                     // all output except OSC pins
	MOVLW       192
	MOVWF       TRISA+0 
;freq.c,61 :: 		TRISB = 0x00;                     // all output
	CLRF        TRISB+0 
;freq.c,62 :: 		TRISC = 0x01;                     // all output except RC0
	MOVLW       1
	MOVWF       TRISC+0 
;freq.c,63 :: 		TRISE = 0xff;                     // all input
	MOVLW       255
	MOVWF       TRISE+0 
;freq.c,65 :: 		Delay_ms(100);                    // Wait for LCD to stabilise
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_main0:
	DECFSZ      R13, 1, 1
	BRA         L_main0
	DECFSZ      R12, 1, 1
	BRA         L_main0
	DECFSZ      R11, 1, 1
	BRA         L_main0
;freq.c,66 :: 		Lcd_Init();                          // Initialize Lcd
	CALL        _Lcd_Init+0, 0
;freq.c,67 :: 		Lcd_Cmd(_LCD_CLEAR);                 // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;freq.c,68 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);            // Turn cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;freq.c,69 :: 		if(RE0_bit){
	BTFSS       RE0_bit+0, BitPos(RE0_bit+0) 
	GOTO        L_main1
;freq.c,71 :: 		Lcd_Out(2,1, "0000000000 Hz   ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr1_freq+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr1_freq+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;freq.c,72 :: 		fc_flag = 1;                         // show that frequency counter selected
	MOVLW       1
	MOVWF       main_fc_flag_L0+0 
;freq.c,73 :: 		}
	GOTO        L_main2
L_main1:
;freq.c,76 :: 		Lcd_Out(2,1, "0000000000      ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr2_freq+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr2_freq+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;freq.c,77 :: 		fc_flag = 0;                         // show that counter selected
	CLRF        main_fc_flag_L0+0 
;freq.c,78 :: 		}
L_main2:
;freq.c,80 :: 		PWM1_Init(2000);                  // Test frequency PWM1 module
	BSF         T2CON+0, 0, 0
	BSF         T2CON+0, 1, 0
	MOVLW       249
	MOVWF       PR2+0, 0
	CALL        _PWM1_Init+0, 0
;freq.c,81 :: 		PWM1_Start();                     // start PWM1
	CALL        _PWM1_Start+0, 0
;freq.c,82 :: 		PWM1_Set_Duty(127 );              // Set current duty for PWM1 50%
	MOVLW       127
	MOVWF       FARG_PWM1_Set_Duty_new_duty+0 
	CALL        _PWM1_Set_Duty+0, 0
;freq.c,83 :: 		T0CON = 0x87;                     // T0 on, 16 bit, prescaler 256
	MOVLW       135
	MOVWF       T0CON+0 
;freq.c,84 :: 		T1CON = 0x85;                     // T1 on, ext input, no prescale
	MOVLW       133
	MOVWF       T1CON+0 
;freq.c,85 :: 		T1GCON = 0x00;                    // no gating
	CLRF        T1GCON+0 
;freq.c,87 :: 		frequency = 0;                // initialise count
	CLRF        main_frequency_L0+0 
	CLRF        main_frequency_L0+1 
	CLRF        main_frequency_L0+2 
	CLRF        main_frequency_L0+3 
;freq.c,88 :: 		TMR1L = 0;                    // reset to 0
	CLRF        TMR1L+0 
;freq.c,89 :: 		TMR1H = 0;                    // reset to 0
	CLRF        TMR1H+0 
;freq.c,92 :: 		while(1){
L_main3:
;freq.c,93 :: 		TMR0H = 0x85;                 // set up timer 0 for 1 second time out
	MOVLW       133
	MOVWF       TMR0H+0 
;freq.c,94 :: 		TMR0L = 0xee;                 // writing TMR0L also writes TMR0H
	MOVLW       238
	MOVWF       TMR0L+0 
;freq.c,95 :: 		INTCON.TMR0IF = 0;            // reset time-out indicator
	BCF         INTCON+0, 2 
;freq.c,96 :: 		if(fc_flag){                  // have we selected frequency rather than counter?
	MOVF        main_fc_flag_L0+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main5
;freq.c,97 :: 		frequency = 0;                // initialise count - comment out
	CLRF        main_frequency_L0+0 
	CLRF        main_frequency_L0+1 
	CLRF        main_frequency_L0+2 
	CLRF        main_frequency_L0+3 
;freq.c,98 :: 		PIR1.TMR1IF = 0;              // initialise
	BCF         PIR1+0, 0 
;freq.c,99 :: 		TMR1L = 0;                    // reset to 0
	CLRF        TMR1L+0 
;freq.c,100 :: 		TMR1H = 0;                    // reset to 0
	CLRF        TMR1H+0 
;freq.c,101 :: 		}
L_main5:
;freq.c,103 :: 		while(!INTCON.TMR0IF){        // loop while waiting for 1 second time-out
L_main6:
	BTFSC       INTCON+0, 2 
	GOTO        L_main7
;freq.c,104 :: 		if(PIR1.TMR1IF){          // monitor frequency count overflow
	BTFSS       PIR1+0, 0 
	GOTO        L_main8
;freq.c,105 :: 		PIR1.TMR1IF=0;        // reset overflow
	BCF         PIR1+0, 0 
;freq.c,106 :: 		frequency += 65536;   // increment count high bytes
	MOVLW       0
	ADDWF       main_frequency_L0+0, 1 
	MOVLW       0
	ADDWFC      main_frequency_L0+1, 1 
	MOVLW       1
	ADDWFC      main_frequency_L0+2, 1 
	MOVLW       0
	ADDWFC      main_frequency_L0+3, 1 
;freq.c,107 :: 		}
L_main8:
;freq.c,108 :: 		}
	GOTO        L_main6
L_main7:
;freq.c,110 :: 		freq_low = (TMR1H << 8) + TMR1L;  // collect frequency bytes
	CLRF        main_freq_low_L0+2 
	CLRF        main_freq_low_L0+3 
	MOVF        TMR1H+0, 0 
	MOVWF       main_freq_low_L0+1 
	CLRF        main_freq_low_L0+0 
	MOVLW       0
	MOVWF       main_freq_low_L0+2 
	MOVWF       main_freq_low_L0+3 
	MOVF        TMR1L+0, 0 
	ADDWF       main_freq_low_L0+0, 1 
	MOVLW       0
	ADDWFC      main_freq_low_L0+1, 1 
	MOVLW       0
	MOVWF       main_freq_low_L0+2 
	MOVWF       main_freq_low_L0+3 
;freq.c,111 :: 		disp_frequency = frequency + freq_low;            // collect frequency bytes
	MOVF        main_freq_low_L0+0, 0 
	ADDWF       main_frequency_L0+0, 0 
	MOVWF       FARG_LongWordToStrWithZeros_input+0 
	MOVF        main_freq_low_L0+1, 0 
	ADDWFC      main_frequency_L0+1, 0 
	MOVWF       FARG_LongWordToStrWithZeros_input+1 
	MOVF        main_freq_low_L0+2, 0 
	ADDWFC      main_frequency_L0+2, 0 
	MOVWF       FARG_LongWordToStrWithZeros_input+2 
	MOVF        main_freq_low_L0+3, 0 
	ADDWFC      main_frequency_L0+3, 0 
	MOVWF       FARG_LongWordToStrWithZeros_input+3 
;freq.c,112 :: 		LongWordToStrWithZeros(disp_frequency, freq_txt);          // covert result to ASCII
	MOVLW       main_freq_txt_L0+0
	MOVWF       FARG_LongWordToStrWithZeros_output+0 
	MOVLW       hi_addr(main_freq_txt_L0+0)
	MOVWF       FARG_LongWordToStrWithZeros_output+1 
	CALL        _LongWordToStrWithZeros+0, 0
;freq.c,113 :: 		Lcd_Out(2,1, freq_txt);       // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       main_freq_txt_L0+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(main_freq_txt_L0+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;freq.c,114 :: 		LATA=LATA^1;                  // show some life by toggling LED
	BTG         LATA+0, 0 
;freq.c,115 :: 		}
	GOTO        L_main3
;freq.c,116 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
