
_main:

;Freq.mbas,47 :: 		main:
;Freq.mbas,50 :: 		ANSELA = 0                                                    ' Configure PORTA pins as digital
	CLRF        ANSELA+0 
;Freq.mbas,51 :: 		ANSELB = 0                                                    ' Configure PORTB pins as digital
	CLRF        ANSELB+0 
;Freq.mbas,52 :: 		ANSELC = 0                                                    ' Configure PORTC pins as digital
	CLRF        ANSELC+0 
;Freq.mbas,53 :: 		ANSELD = 0                                                    ' Configure PORTD pins as digital
	CLRF        ANSELD+0 
;Freq.mbas,54 :: 		ADCON0 = 0                                                    ' A/D off
	CLRF        ADCON0+0 
;Freq.mbas,55 :: 		ADCON1 = 0x0f                                                 ' all digital
	MOVLW       15
	MOVWF       ADCON1+0 
;Freq.mbas,56 :: 		CM1CON0 = 0                                                   ' disable 18F45K22 comparator
	CLRF        CM1CON0+0 
;Freq.mbas,57 :: 		CM2CON0 = 0                                                   ' disable 18F45K22 comparator
	CLRF        CM2CON0+0 
;Freq.mbas,59 :: 		LATA = 0                                                      ' all off
	CLRF        LATA+0 
;Freq.mbas,60 :: 		LATB = 0xff                                                   ' disable GLCD if fitted
	MOVLW       255
	MOVWF       LATB+0 
;Freq.mbas,61 :: 		LATC = 0                                                      ' all off
	CLRF        LATC+0 
;Freq.mbas,62 :: 		TRISA = 0xC0                                                  ' all output except OSC pins
	MOVLW       192
	MOVWF       TRISA+0 
;Freq.mbas,63 :: 		TRISB = 0x00                                                  ' all output
	CLRF        TRISB+0 
;Freq.mbas,64 :: 		TRISC = 0x01                                                  ' all output except RC0
	MOVLW       1
	MOVWF       TRISC+0 
;Freq.mbas,66 :: 		Delay_ms(100)                                                 ' Wait for LCD to stabilise
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L__main1:
	DECFSZ      R13, 1, 1
	BRA         L__main1
	DECFSZ      R12, 1, 1
	BRA         L__main1
	DECFSZ      R11, 1, 1
	BRA         L__main1
;Freq.mbas,67 :: 		Lcd_Init()                                                    ' Initialize Lcd
	CALL        _Lcd_Init+0, 0
;Freq.mbas,68 :: 		Lcd_Cmd(_LCD_CLEAR)                                           ' Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Freq.mbas,69 :: 		Lcd_Cmd(_LCD_CURSOR_OFF)                                      ' Turn cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Freq.mbas,71 :: 		Lcd_Out(2,1, "0000000000 Hz   ")                              ' Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       48
	MOVWF       ?LocalText_main+0 
	MOVLW       48
	MOVWF       ?LocalText_main+1 
	MOVLW       48
	MOVWF       ?LocalText_main+2 
	MOVLW       48
	MOVWF       ?LocalText_main+3 
	MOVLW       48
	MOVWF       ?LocalText_main+4 
	MOVLW       48
	MOVWF       ?LocalText_main+5 
	MOVLW       48
	MOVWF       ?LocalText_main+6 
	MOVLW       48
	MOVWF       ?LocalText_main+7 
	MOVLW       48
	MOVWF       ?LocalText_main+8 
	MOVLW       48
	MOVWF       ?LocalText_main+9 
	MOVLW       32
	MOVWF       ?LocalText_main+10 
	MOVLW       72
	MOVWF       ?LocalText_main+11 
	MOVLW       122
	MOVWF       ?LocalText_main+12 
	MOVLW       32
	MOVWF       ?LocalText_main+13 
	MOVLW       32
	MOVWF       ?LocalText_main+14 
	MOVLW       32
	MOVWF       ?LocalText_main+15 
	CLRF        ?LocalText_main+16 
	MOVLW       ?LocalText_main+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?LocalText_main+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Freq.mbas,73 :: 		PWM1_Init(2000)                                               ' Test frequency PWM1 module
	BCF         T2CON+0, 0, 0
	BCF         T2CON+0, 1, 0
	BSF         T2CON+0, 0, 0
	BSF         T2CON+0, 1, 0
	MOVLW       249
	MOVWF       PR2+0, 0
	CALL        _PWM1_Init+0, 0
;Freq.mbas,74 :: 		PWM1_Start()                                                  ' start PWM1
	CALL        _PWM1_Start+0, 0
;Freq.mbas,75 :: 		PWM1_Set_Duty(127 )                                           ' Set current duty for PWM1 50%
	MOVLW       127
	MOVWF       FARG_PWM1_Set_Duty_new_duty+0 
	CALL        _PWM1_Set_Duty+0, 0
;Freq.mbas,76 :: 		T0CON = 0x87                                                  ' T0 on, 16 bit, prescaler 256
	MOVLW       135
	MOVWF       T0CON+0 
;Freq.mbas,77 :: 		T1CON = 0x85                                                  ' T1 on, ext input, no prescale
	MOVLW       133
	MOVWF       T1CON+0 
;Freq.mbas,78 :: 		T1GCON = 0x00                                                 ' no gating
	CLRF        T1GCON+0 
;Freq.mbas,81 :: 		while TRUE
L__main3:
;Freq.mbas,82 :: 		TMR0H = 0x85                                              ' set up timer 0 for 1 second time out
	MOVLW       133
	MOVWF       TMR0H+0 
;Freq.mbas,83 :: 		TMR0L = 0xee                                              ' writing TMR0L also writes TMR0H
	MOVLW       238
	MOVWF       TMR0L+0 
;Freq.mbas,84 :: 		INTCON.TMR0IF = 0                                         ' reset time-out indicator
	BCF         INTCON+0, 2 
;Freq.mbas,85 :: 		frequency = 0                                             ' initialise count
	CLRF        _frequency+0 
	CLRF        _frequency+1 
	CLRF        _frequency+2 
	CLRF        _frequency+3 
;Freq.mbas,86 :: 		TMR1L = 0                                                 ' reset to 0
	CLRF        TMR1L+0 
;Freq.mbas,87 :: 		TMR1H = 0                                                 ' reset to 0
	CLRF        TMR1H+0 
;Freq.mbas,88 :: 		PIR1.TMR1IF = 0                                           ' initialise
	BCF         PIR1+0, 0 
;Freq.mbas,90 :: 		while INTCON.TMR0IF = 0                                   ' loop while waiting for 1 second time-out
L__main8:
	BTFSC       INTCON+0, 2 
	GOTO        L__main9
;Freq.mbas,91 :: 		if PIR1.TMR1IF = 1 then                               ' monitor frequency count overflow
	BTFSS       PIR1+0, 0 
	GOTO        L__main13
;Freq.mbas,92 :: 		PIR1.TMR1IF = 0                                   ' reset overflow
	BCF         PIR1+0, 0 
;Freq.mbas,93 :: 		frequency = frequency + 65536                     ' increment count high bytes
	MOVLW       0
	ADDWF       _frequency+0, 1 
	MOVLW       0
	ADDWFC      _frequency+1, 1 
	MOVLW       1
	ADDWFC      _frequency+2, 1 
	MOVLW       0
	ADDWFC      _frequency+3, 1 
L__main13:
;Freq.mbas,95 :: 		wend
	GOTO        L__main8
L__main9:
;Freq.mbas,97 :: 		freq_low = (TMR1H << 8) + TMR1L                           ' collect frequency bytes
	CLRF        R2 
	CLRF        R3 
	MOVF        TMR1H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        TMR1L+0, 0 
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	ADDWFC      R2, 1 
	ADDWFC      R3, 1 
	MOVF        R0, 0 
	MOVWF       _freq_low+0 
	MOVF        R1, 0 
	MOVWF       _freq_low+1 
	MOVF        R2, 0 
	MOVWF       _freq_low+2 
	MOVF        R3, 0 
	MOVWF       _freq_low+3 
;Freq.mbas,98 :: 		frequency = frequency + freq_low                          ' collect frequency bytes
	MOVF        _frequency+0, 0 
	ADDWF       R0, 1 
	MOVF        _frequency+1, 0 
	ADDWFC      R1, 1 
	MOVF        _frequency+2, 0 
	ADDWFC      R2, 1 
	MOVF        _frequency+3, 0 
	ADDWFC      R3, 1 
	MOVF        R0, 0 
	MOVWF       _frequency+0 
	MOVF        R1, 0 
	MOVWF       _frequency+1 
	MOVF        R2, 0 
	MOVWF       _frequency+2 
	MOVF        R3, 0 
	MOVWF       _frequency+3 
;Freq.mbas,99 :: 		LongWordToStrWithZeros(frequency, freq_txt)               ' covert result to ASCII
	MOVF        R0, 0 
	MOVWF       FARG_LongWordToStrWithZeros_input+0 
	MOVF        R1, 0 
	MOVWF       FARG_LongWordToStrWithZeros_input+1 
	MOVF        R2, 0 
	MOVWF       FARG_LongWordToStrWithZeros_input+2 
	MOVF        R3, 0 
	MOVWF       FARG_LongWordToStrWithZeros_input+3 
	MOVLW       _freq_txt+0
	MOVWF       FARG_LongWordToStrWithZeros_output+0 
	MOVLW       hi_addr(_freq_txt+0)
	MOVWF       FARG_LongWordToStrWithZeros_output+1 
	CALL        _LongWordToStrWithZeros+0, 0
;Freq.mbas,100 :: 		Lcd_Out(2,1, freq_txt)                                    ' Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       _freq_txt+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(_freq_txt+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Freq.mbas,101 :: 		LATA = LATA xor 1                                         ' show some life by toggling LED
	BTG         LATA+0, 0 
;Freq.mbas,102 :: 		wend
	GOTO        L__main3
L_end_main:
	GOTO        $+0
; end of _main
